  processor 6502

  seg
  org $8000
  byte 0
  org $8100
  nop $1FF8

  org $8155  ; Jumping-in point in $1FF9 block (from $1FF8)
  nop $1FF9

  org $8169  ; Jumping-in point in $1FF8 block (from $1FF9)
  nop $1FF8

  org $8553  ; Jumping-out point in $1FF9 block (going to $1FF8)
  jmp $5169

  org $8C39  ; Jumping-out point in $1FF8 block (going to $1FF9)
  jmp $5155

  org $8FFC
  word $9100,$9100
  org $9100
  nop $1FF8

  org $9871-3  ; Draw things on scanner here
drawx:
  nop $1FF8
  lda #$00
  ldy #6
zlp:
  sta $F04F,y
  sta $F04F+7,y
  sta $F04F+14,y
  sta $F04F+21,y
  sta $F04F+28,y
  sta $F04F+35,y
  dey
  bpl zlp

  ldx #15
dlp:
  dex
  bmi dlp_exit
dlp1:
  lda $F0A2,x
  beq dlp
  eor $81
  and #1
  beq dlp
  lda $F082,x
  asl
  lda $F0B2,x
  rol
  and #7
  tay
  lda xatable,y
  beq dlp
  sta $F07F
  lda $F082,x  ; X position low byte
  and #$7F
  lsr
  lsr
  lsr
  lsr
  tay
  lda xdtable,y
  sta $F0
  lda $E0,x ; Y position
  lsr
  lsr
  lsr
  tay
  lda ytable,y
  clc
  adc $F0FF
  tay
  lda $F0CE,y
  ora $F0
  sta $F04E,y
  dex
  bpl dlp1
dlp_exit:
  ldx $F0F9
  bpl f9ok
  ldx #15
  dex
f9ok:
  sta $f079
  ldx $F0FA
  lda FAtbl,x
  sta $F07A

  lda $81
  lsr
  lda #$8C
  ror
  sta $f07F

  
  jmp x908

  org $9908
x908:
  nop $1FF8

  org $9A00
xatable:
  byte 15,23,29,36,0,0,1,8
xdtable:
  byte 128,64,32,16,8,4,2,1
ytable:  ; DCD8
  byte 255,0,0,1,1,2,2,3,3,3,4,4,5,5,6,6,6,6
FAtbl:
  byte 1,2,3,6,0,0,7,0

  org $9FFC
  word $9100,$9100

  end






